# HG changeset patch
# Parent  21465b621b7886a77b12b6bc5acbea73a6f37a4e
Use gdk_event_peek instead of gdk_events_pending in drain_queue.

diff -r 21465b621b78 -r e8e82b6d2a74 src/event-gtk.c
--- a/src/event-gtk.c	Sat Dec 23 17:37:09 2017 +0900
+++ b/src/event-gtk.c	Mon Dec 25 00:05:43 2017 +0900
@@ -1700,8 +1700,17 @@
      system events.
   */
   if (gdk_display_get_default ())
-    while (gdk_events_pending ())
-      gtk_main_iteration_do (FALSE);
+    /* #### gdk_events_pending is broken; it returns 1 even though
+       gdk_event_peek returns NULL. */
+    /* while (gdk_events_pending ()) */
+    {
+      GdkEvent *e = gdk_event_peek();
+      while (e) {
+	gtk_main_iteration_do (FALSE);
+	gdk_event_free(e);
+	e = gdk_event_peek();
+      }
+    }
 
 #ifdef HAVE_TTY
   drain_tty_devices ();
